#include <avr/interrupt.h>
#include "types.h"
#include "config.h"

volatile int16_t enc_delta;
volatile int8_t enc_delta1;
volatile int8_t enc_delta2;

void encode_init( void )
{
	enc_delta = 0;
	enc_delta1 = 0;
	enc_delta2 = 0;
}


int16_t encodeRead( void )
{
	int16_t val;

	cli();
	val = enc_delta;
	enc_delta = 0;
	sei();
	return val;
}

int8_t encodeRead1( void )
{
	int8_t val;

	cli();
	val = enc_delta1;
	enc_delta1 = val & 3;
	sei();
	return val>>2;
}

int8_t encodeRead2( void )
{
	int8_t val;

	cli();
	val = enc_delta2;
	enc_delta2 = val & 3;
	sei();
	return val>>2;
}
